////Test 1: Test the current ambient light intensity
//void setup(){
//  Serial.begin(9600);
//  pinMode(3,OUTPUT);
//}
//void loop(){
//  digitalWrite(3,255);
//  int ambientLight=analogRead(A0);
//  Serial.println(ambientLight);
//  Serial.end();
//}

////Test 2: Photocell sensing code with PID control and serial plot in arduino plotter
//float Kp=0.1, Ki=0, Kd=0;
//float error=0, previous_error=0;
//float P=0, I=0, D=0;
//float PID_value=0;
//int setPoint=800;
//float initialValue=10;
//void setup() {
//  pinMode(3,OUTPUT);
//  analogWrite(3,initialValue);
//  Serial.begin(9600);
//}
void loop() {
  int photoSignal=analogRead(A0);
  error=setPoint-photoSignal;
  P=error;
  I+=error;
  D=error-previous_error;
  previous_error=error;
  PID_value=PID_value+Kp*P+Ki*I+Kd*D; 
  analogWrite(3,PID_value);
  Serial.print(setPoint);
  Serial.print(" "); 
  Serial.println(photoSignal);
}

 
// Test 3: Photocell PID with setPoint variable
float Kp=0.1, Ki=0, Kd=0;
float error=0, previous_error=0;
float P=0, I=0, D=0;
float PID_value=0;
int setPoint=800;
float initialValue=10;
int buttonState;
int lastButtonState;
void setup() {
  pinMode(3,OUTPUT);
  pinMode(4,INPUT);
  analogWrite(3,initialValue);
  Serial.begin(9600);
}
void loop() {
  setPointChange();
  int photoSignal=analogRead(A0);
  error=setPoint-photoSignal;
  P=error;
  I+=error;
  D=error-previous_error;
  previous_error=error;
  PID_value=PID_value+Kp*P+Ki*I+Kd*D; 
  analogWrite(3,PID_value);
  Serial.print(setPoint);
  Serial.print(" "); 
  Serial.println(photoSignal);
}

void setPointChange(){ // state detection (edge detection) works. 
  buttonState=digitalRead(4);
  if (buttonState!=lastButtonState){
    if (buttonState==HIGH){
      if (setPoint<900){
        setPoint+=20;
      }
    }
  }
  lastButtonState=buttonState;
}




//void setPointChange(){ // button push detection, why this won't work?
//  int setPointPin=digitalRead(4);
//  if (setPointPin==HIGH){
//    delay(10);
//    if (setPointPin==HIGH){
//      if (setPoint<950){
//        setPoint+=10;
//      }
//    }
//  }
//}
